#ifndef _GLOBAL_H_
#define _GLOBAL_H_

#include "vdsllib.h"
#ifdef __KERNEL__
#include "offtime.h"
#endif

//===mapper.c===
extern mt_uint32 map[MAX_CHIPS];

//===vdsllib.c===
#ifdef __KERNEL__
extern struct tm boottime;
#endif
//extern char* profile_name_prefix;
//user notification callback
extern mt_uint32 masker_notification;
extern mt_uint32 masker_status;

extern mt_uint32 line15[MAX_PORTS][MT_IDX_LINE][MT_INV_MAX15][MT_LINE_SIZE15];
extern mt_uint32 lineinit15[MAX_PORTS][MT_IDX_LINE][MT_INV_MAX15][MT_LINEINIT_SIZE15];
extern mt_uint32 chan15[MAX_PORTS][MT_IDX_CHAN][MT_INV_MAX15][MT_CHAN_SIZE15];
extern mt_uint32 line24[MAX_PORTS][MT_IDX_LINE][MT_INV_MAX24][MT_LINE_SIZE24];
extern mt_uint32 lineinit24[MAX_PORTS][MT_IDX_LINE][MT_INV_MAX24][MT_LINEINIT_SIZE24];
extern mt_uint32 chan24[MAX_PORTS][MT_IDX_CHAN][MT_INV_MAX24][MT_CHAN_SIZE24];

//yalee980519 for tr069 
//extern mt_uint32 g_vdsl_init_showtime_flag;
extern mt_uint32 g_ShowtimeLinkRetrain[MAX_PORTS];
extern mt_uint32 g_ShowtimeInitErrors[MAX_PORTS];
extern mt_uint32 g_ShowtimeInitTimeouts[MAX_PORTS];
extern mt_uint32 g_ShowtimeErroredSecs[MAX_PORTS];
extern mt_uint32 g_ShowtimeSeverelyErroredSecs[MAX_PORTS];
extern mt_uint32 g_ShowtimeFECErrors[MAX_PORTS];
extern mt_uint32 g_ShowtimeATUCFECErrors[MAX_PORTS];
extern mt_uint32 g_ShowtimeCRCErrors[MAX_PORTS];
extern mt_uint32 g_ShowtimeATUCErroredSecs[MAX_PORTS];
extern mt_uint32 g_ShowtimeATUCCRCErrors[MAX_PORTS];
extern mt_uint32 g_ShowtimeATUCSeverelyErroredSecs[MAX_PORTS];


extern mt_uint32 g_LastShowtimeLinkRetrain[MAX_PORTS];
extern mt_uint32 g_LastShowtimeInitErrors[MAX_PORTS];
extern mt_uint32 g_LastShowtimeInitTimeouts[MAX_PORTS];
extern mt_uint32 g_LastShowtimeErroredSecs[MAX_PORTS];
extern mt_uint32 g_LastShowtimeSeverelyErroredSecs[MAX_PORTS];
extern mt_uint32 g_LastShowtimeFECErrors[MAX_PORTS];
extern mt_uint32 g_LastShowtimeATUCFECErrors[MAX_PORTS];
extern mt_uint32 g_LastShowtimeCRCErrors[MAX_PORTS];
extern mt_uint32 g_LastShowtimeATUCErroredSecs[MAX_PORTS];
extern mt_uint32 g_LastShowtimeATUCCRCErrors[MAX_PORTS];
extern mt_uint32 g_LastShowtimeATUCSeverelyErroredSecs[MAX_PORTS];

extern mt_uint32 g_init_ShowtimeLinkRetrain[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeInitErrors[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeInitTimeouts[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeErroredSecs[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeSeverelyErroredSecs[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeFECErrors[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeATUCFECErrors[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeCRCErrors[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeATUCErroredSecs[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeATUCCRCErrors[MAX_PORTS];
extern mt_uint32 g_init_ShowtimeATUCSeverelyErroredSecs[MAX_PORTS];

// mt_uint32 default_alarm_profile[9];
// mt_uint32 default_profile[45];

// -------------------------- Template MIB hot -----------------------
// mib_entry_struct mib_entrys_curr_phy[6];

// -------------------------- Profile -----------------------
//profile name storage buffer
//extern char profile_name_list[MAX_PORTS][MT_MIB_ConfProfileNameMaxLength];

//===hdlc.c===
extern int hdlc_frame;

//===chip.c===
extern unsigned int rw_delay;
extern unsigned int r_delay;
extern unsigned int w_delay;
extern unsigned int hdr_delay;
extern unsigned int trans_delay;
extern int manuallen;
extern int readdsp;
extern chip_t chips[MAX_CHIPS];

//===if.c===
extern mt_uint8 connect_status;
extern mt_uint8 auto_reset;
extern mt_uint8 board_type;
extern unsigned long atomic_ops;
extern port_info_struct port_info[MAX_PORTS];
extern int add_start[100];
extern int bd[(16/4)*1024];

//===port.c===
#ifdef XENOS
extern port_t port[MAX_PORTS];
#elif defined (HOPE)
extern port_t port[MAX_PORTS];
#elif defined (BOARD_A5)
extern port_t port[MAX_PORTS];
#elif defined (AWARD)
extern port_t port[MAX_PORTS];
#endif

//===awardm.c===
#ifdef XENOS
extern volatile mt_uint8 *falcon_port;
#endif
#ifdef HOPE
extern volatile mt_uint8 *falcon_port;
#endif
#ifdef BOARD_A5
extern volatile mt_uint8 *falcon_port;
extern volatile mt_uint32 *databit_set;
extern volatile mt_uint32 *databit_clr;
#endif

#endif	//_GLOBAL_H_
