#ifndef _BOARDDRV_H_
#define _BOARDDRV_H_

#ifndef __KERNEL__
#define __KERNEL__
#endif
#ifndef MODULE
#define MODULE
#endif

#include <linux/module.h>
#include <linux/config.h>
#include <linux/version.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/errno.h>
#include <linux/ioctl.h>
#include <linux/types.h>
#include <linux/proc_fs.h>
#include <asm/io.h>
#include <asm/uaccess.h>

#include "boardioctl.h"

#ifdef HOPE
#include "rtl8310p_sw.h"
#elif defined BOARD_A5
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif

#define FLASH_CFG_ADDR  0x10020000
#define FLASH_CFG_SIZE  0x20000

int meta_info(char *buf, char **start, off_t offset, int count, int *eof, void *data);
void flash_env_info(char *buf, int *len);
int search_env(char *search_name , u8 *search_addr );
int init_fakevdsl(void);
void cleanup_fakevdsl_module(void);

extern void vdsl_proc_msg(char *buf, int *len);
//extern void switch_proc_msg(char *buf, int *len);

#ifdef BOARD_A5
extern int smi_read(unsigned int addr, unsigned int* data);
extern int smi_write(unsigned int addr,unsigned short data);
#endif


#endif	//_BOARDDRV_H_

